#!/bin/bash
#радиус цилиндра, мм
R=4;
#длина цилиндра
L=8;
#сторона куба
A=5;

#основные размеры
pi=`echo "scale=10; 4*a(1)" | bc -lq`;

#коэффициенты дробления
#количество ячеек от боковой поверхности цилиндра до куба
c2=40;
#количество ячеек от торцевой поверхности цилиндра до куба
cz1=40;
#количество ячеек куба
c1=40;

#точки
x0=$R;
y0=0;
x1=`echo "scale=10; $R*c($pi/4)" | bc -lq`;
y1=`echo "scale=10; $R*s($pi/4)" | bc -lq`;
x2=`echo "scale=10; $R*c($pi/2)" | bc -lq`;
y2=`echo "scale=10; $R*s($pi/2)" | bc -lq`;
x3=`echo "scale=10; $R*c($pi*3/4)" | bc -lq`;
y3=`echo "scale=10; $R*s($pi*3/4)" | bc -lq`;
x4=-$R;
y4=0;
x5=`echo "-($x1)" | bc -lq`;
y5=`echo "-($y1)" | bc -lq`;
x6=`echo "-($x2)" | bc -lq`;
y6=`echo "-($y2)" | bc -lq`;
x7=`echo "-($x3)" | bc -lq`;
y7=`echo "-($y3)" | bc -lq`;
x8=`echo "sqrt(2)*$A/2" | bc -lq`;
y8=0;
x9=0;
y9=`echo "sqrt(2)*$A/2" | bc -lq`;
x10=`echo "-(sqrt(2)*$A/2)" | bc -lq`;
y10=0;
x11=0;
y11=`echo "-sqrt(2)*$A/2" | bc -lq`;

z0=`echo "-$L/2" | bc -lq`;
z1=`echo "-$A/2" | bc -lq`;
z2=`echo "$A/2" | bc -lq`;
z3=`echo "$L/2" | bc -lq`;

# Генерируем blockMeshDict
echo '/*--------------------------------*- C++ -*----------------------------------*\';
echo '| =========                 |                                                 |';
echo '| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |';
echo '|  \\    /   O peration     | Version:  2.1.1                                 |';
echo '|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |';
echo '|    \\/     M anipulation  |                                                 |';
echo '\*---------------------------------------------------------------------------*/';
echo 'FoamFile';
echo '{';
echo '    version     2.0;';
echo '    format      ascii;';
echo '    class       dictionary;';
echo '    object      blockMeshDict;';
echo '}';
echo '// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //';
echo '';
echo 'convertToMeters 0.001;';
echo '';
echo 'vertices';
echo '(';

for k in $z0 $z1 $z2 $z3
do
	i=0
	while [ $i -lt 12 ]
		do
			string1=$'x'$i;
			string2=$'y'$i;
			echo "(${!string1} ${!string2} $k)";
			i=$[$i+1];
		done;
done;

echo ');';
echo "blocks";
echo '(';
echo "hex (0 2 9 8 12 14 21 20) ($c1 $c2 $cz1) simpleGrading (1 1 1)";
echo "hex (2 4 10 9 14 16 22 21) ($c1 $c2 $cz1) simpleGrading (1 1 1)";
echo "hex (4 6 11 10 16 18 23 22) ($c1 $c2 $cz1) simpleGrading (1 1 1)";
echo "hex (6 0 8 11 18 12 20 23) ($c1 $c2 $cz1) simpleGrading (1 1 1)";
echo "hex (8 9 10 11 20 21 22 23) ($c2 $c2 $cz1) simpleGrading (1 1 1)";
echo "hex (12 14 21 20 24 26 33 32) ($c1 $c2 $c2) simpleGrading (1 1 1)";
echo "hex (14 16 22 21 26 28 34 33) ($c1 $c2 $c2) simpleGrading (1 1 1)";
echo "hex (16 18 23 22 28 30 35 34) ($c1 $c2 $c2) simpleGrading (1 1 1)";
echo "hex (18 12 20 23 30 24 32 35) ($c1 $c2 $c2) simpleGrading (1 1 1)";
echo "hex (24 26 33 32 36 38 45 44) ($c1 $c2 $cz1) simpleGrading (1 1 1)";
echo "hex (26 28 34 33 38 40 46 45) ($c1 $c2 $cz1) simpleGrading (1 1 1)";
echo "hex (28 30 35 34 40 42 47 46) ($c1 $c2 $cz1) simpleGrading (1 1 1)";
echo "hex (30 24 32 35 42 36 44 47) ($c1 $c2 $cz1) simpleGrading (1 1 1)";
echo "hex (32 33 34 35 44 45 46 47) ($c2 $c2 $cz1) simpleGrading (1 1 1)";
echo ');';
echo "edges"
echo '(';
echo "arc 0 2 ($x1 $y1 $z0)";
echo "arc 2 4 ($x3 $y3 $z0)";
echo "arc 4 6 ($x5 $y5 $z0)";
echo "arc 6 0 ($x7 $y7 $z0)";
echo "arc 12 14 ($x1 $y1 $z1)";
echo "arc 14 16 ($x3 $y3 $z1)";
echo "arc 16 18 ($x5 $y5 $z1)";
echo "arc 18 12 ($x7 $y7 $z1)";
echo "arc 24 26 ($x1 $y1 $z2)";
echo "arc 26 28 ($x3 $y3 $z2)";
echo "arc 28 30 ($x5 $y5 $z2)";
echo "arc 30 24 ($x7 $y7 $z2)";
echo "arc 36 38 ($x1 $y1 $z3)";
echo "arc 38 40 ($x3 $y3 $z3)";
echo "arc 40 42 ($x5 $y5 $z3)";
echo "arc 42 36 ($x7 $y7 $z3)";
echo ');';
echo "boundary";
echo '(';
        echo "cube";
        echo '{';
                echo "type patch;";
                echo "faces"
                        echo '(';
				echo "(20 21 22 23)";
				echo "(20 32 33 21)";
				echo "(21 33 34 22)";
				echo "(22 34 35 23)";
				echo "(23 35 32 20)";
				echo "(32 35 34 33)";
                        echo ');';
        echo '}';
echo ');';
echo '// ************************************************************************* //';

